/*
 * Proyecto: SampleWebCam
 * Fichero: FrmPrincipal.prg
 * Descripcin:
 * Autor:
 * Fecha: 11/01/2021
 */

#include "Xailer.ch"

CLASS TFrmPrincipal FROM TForm

   DATA oOcx

   COMPONENT oBvCaptura
   COMPONENT oImage1
   COMPONENT oImage2
   COMPONENT oBtnCaptura
   COMPONENT oBtnMarcar
   COMPONENT oComboboxMod1
   COMPONENT oEditMod1

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD BtnCapturaClick( oSender )
   METHOD BtnMarcarClick( oSender )

ENDCLASS

#include "FrmPrincipal.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TFrmPrincipal

   if ConectaCamara( @::oOcx, ::oBvCaptura, 1 )
      ::oOcx:PreviewRate( 1 )
      ::oOcx:Preview(.T.)
      ::oOcx:PreviewScale(.T.)

      ::oComboboxMod1:aItems := ::oOcx:ListDrivers
      ::oComboboxMod1:nIndex := 1
   ENDIF

   ::oEditMod1:Value := DToC( Date() ) + " " + Time()

RETURN Nil

//------------------------------------------------------------------------------

METHOD BtnCapturaClick( oSender ) CLASS TFrmPrincipal
   LOCAL cTmpCaptura := GetNewFileName(Application:cDirectory+"Capturas", "jpg")

   ::oOcx:SaveFoto(cTmpCaptura)

   ::oEditMod1:Value := DToC( Date() ) + " " + Time()

   WITH OBJECT ::oImage1
      IF :oPicture == Nil
         :oPicture := TPicture():New()
      ENDIF
      :oPicture:LoadFromFile(cTmpCaptura)
      :Cargo := cTmpCaptura
      :Refresh()
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD BtnMarcarClick( oSender ) CLASS TFrmPrincipal
   LOCAL cMarcada := Left( ::oImage1:Cargo, Len( ::oImage1:Cargo ) - 4 ) + "_Mark.jpg"
   LOCAL cTmp     := Left( ::oImage1:Cargo, Len( ::oImage1:Cargo ) - 4 ) + "~tmp.jpg"
   local cS := Chr(34)
   LOCAL cExecute
   LOCAL nHeight := ::oImage1:oPicture:nHeight , nWidth := ::oImage1:oPicture:nWidth
   LOCAL cBox    := "10," + ToString( nHeight - 50 ) + " " + ToString( nWidth - 10 ) + "," +  ToString( nHeight - 10 )

   WITH OBJECT ::oImage2
      IF :oPicture == Nil
         :oPicture := TPicture():New()
      ENDIF
      ::oImage1:oPicture:Save(cTmp)
      if File(Application:cDirectory + "IM86\convert.exe")
         // Podemos aadir la fecha a la imagen
         // abajo
         cExecute := Application:cDirectory + "IM86\convert.exe " + cS + cTmp + cS + ;
                     " -fill " + cS + "rgb(250,250,250)" + cS + ;
                     " -draw " + cS + "rectangle " + cBox + cS + ;
                     " -fill black -pointsize " + cS + "40" + cS + ;
                     " -draw " + cS + "text 20," + ToString( nHeight - 15 ) + " '" + ::oEditMod1:Value + "'" + cS + ;
                     " " + cS + cMarcada + cS
         Execute(cExecute,Application:cDirectory + "IM86" ,.T.,0)
         if !File(cMarcada)
            copy File (cTmp) TO (cMarcada)
         endif
      else
         copy File (cTmp) TO (cMarcada)
      endif
      :oPicture:LoadFromFile(cMarcada)
      :Redraw()
   end WITH
   FErase(cTmp)

RETURN Nil

//------------------------------------------------------------------------------
