/*
 * Proyecto: SampleWebCam
 * Fichero: TWebCam.prg
 * Descripcin:
 * Autor:
 * Fecha: 11/01/2021
 */

#include "Xailer.ch"

#define  GHW_HWNDFIRST 0
#define  GHW_HWNDNEXT  2
#define  GWW_HINSTANCE -6

//------------------------------------------------------------------------------
/**
  Clase de captura de imgenes a travs de WebCam

  Original de Rafa Carmona THE FULL
  con la colaboracin de Jos Laln

  Modificaciones de Pablo Herranz y Bingen Ugaldebere

   ATENCIN !! hay que incluir la librera avicap32 de mingw
**/

//------------------------------------------------------------------------------
CLASS tWebCamCapture FROM TControl

     DATA oWnd, hWndC
     DATA nIndex INIT 0    // By Default index first found

     METHOD New() CONSTRUCTOR
     METHOD Connect()               INLINE ConnectDriver(::hWndC, ::nIndex )
     METHOD End()                   INLINE DisConnectDriver(::hWndC )
     METHOD StartCapture()          INLINE Capture(::hWndC )
     METHOD StopCapture()           INLINE CaptureStop(::hWndC )
     METHOD Preview( lPreview )     INLINE CapPreview(  ::hWndC, lPreview )
     METHOD PreviewRate( nRate )    INLINE CapPreviewRate(::hWndC, nRate )
     METHOD PreViewScale( lScale )  INLINE CapPreviewScale(::hWndC,lScale )
     METHOD CreateWndCapture()
     METHOD FileSaveAs( cFileName ) INLINE CapFileSaveAs(::hWndC, cFilename )
     METHOD SaveFoto( cFile )       INLINE capFileSaveDIB(::hWndC, cFile)
     *METHOD SetFile( cFile )        INLINE CapFileSetWebCamCaptureFile( ::hWndC, cFile )
     METHOD SetupCapture()          INLINE CapCaptureSetSetup( ::hWndC )

     METHOD SetupVideo()            INLINE SetupVideo(::hWndC )
     *METHOD Overlay( lMode )        INLINE CapOverlay(::hWndC, lMode )
     *METHOD FramesPerSec( nFrames ) INLINE CapFramesPerSec( ::hWndC, nFrames )
     *METHOD VideoCompression()      INLINE CapDlgVideoCompression( ::hWndC )
     METHOD ListDrivers()
     METHOD EnumDrivers()

END CLASS

//------------------------------------------------------------------------------

METHOD New( oCtrl ) CLASS tWebCamCapture
  ::oWnd := oCtrl
   IF Len( CapGetDrivers() ) > 0
      ::CreateWndCapture()
   ELSE
     Application:lBusy:=.F.
     MsgStop("No se ha encontrado el driver de la cmara Web")
   ENDIF

RETURN Self

//------------------------------------------------------------------------------

METHOD EnumDrivers() CLASS tWebCamCapture
Return( Len( ::ListDrivers() ) )

//------------------------------------------------------------------------------

METHOD ListDrivers() CLASS tWebCamCapture
Local aWebcamDrivers := {}, xItem
LOCAL aTmp :=CapGetDrivers(), nItem:=0

   For EACH xItem IN aTmp
      If xItem <> Nil
         AAdd( aWebcamDrivers, xItem )
      Endif
   Next
Return aWebcamDrivers

//------------------------------------------------------------------------------
METHOD CreateWndCapture() CLASS tWebCamCapture
::hWndC := CaptureWin( "", nOR( WS_CHILD, WS_VISIBLE  ),;
                          ::oWnd:nClientLeft, ::oWnd:nClientTop,;
                          ::oWnd:nClientWidth,::oWnd:nClientHeight,;
                          ::oWnd:handle, 0 )
RETURN NIL

//------------------------------------------------------------------------------

FUNCTION ConectaCamara( oOcx, oParent, nItem )

   if oOcx == Nil
      with Object oOcx:=tWebCamCapture():New(oParent)
         If :EnumDrivers()=0
            Application:lBusy:=.F.
            MsgStop("No hay ninguna cmara web instalada en este equipo o no est correctamente configurada.")
            oOcx:End()
            Return .F.
         Endif
         :nIndex:= nItem-1
         LogDebug( :Connect() )
      End
   endif
return .T.

//------------------------------------------------------------------------------

FUNCTION GetNewFileName(cPath, cExt, nLen)
   local cTmp := ""
   local lOk := .T.
   local nI, cSemilla := "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"

   DEFAULT cExt TO ".tmp"
   DEFAULT nLen TO 10

   IF Right(cPath,1) <> "\"
      cPath += "\"
   ENDIF

   IF Left(cExt,1) <> "."
      cExt := "." + cExt
   ENDIF

   do while lOk
      cTmp := ""
      for nI := 1 to nLen
         cTmp += SubStr( cSemilla, HB_Random( Len(cSemilla) ), 1 )
      next
      cTmp := cPath + cTmp + cExt
      lOk := File(cTmp)
   enddo
RETURN cTmp

//------------------------------------------------------------------------------

#pragma BEGINDUMP

#include <windows.h>
#include <vfw.h>
#include "hbapi.h"
#include "winable.h"
#include "Xailer.h"
#include "math.h"

HB_FUNC( CAPTUREWIN )
{
 HWND hVentana = (HWND) capCreateCaptureWindow( hb_parc( 1 ), (DWORD) hb_parnl( 2 ), hb_parni( 3 ) ,hb_parni( 4 ),hb_parni( 5 ),hb_parni( 6 ),
(HWND) hb_parnl( 7 ),hb_parni(8) );
  hb_retnl( (LONG) hVentana );
}

HB_FUNC( CAPTURE )
{
 hb_retl( SendMessage ( (HWND) hb_parnl( 1 ),
WM_CAP_SEQUENCE, 0, 0L) );
}


HB_FUNC( CAPTURESTOP )
{
  hb_retl( SendMessage ( (HWND) hb_parnl( 1 ), WM_CAP_STOP,0, 0L) );
}


HB_FUNC( CAPCAPTURESEQUENCENOFILE )
{
  hb_retl( capCaptureSequenceNoFile( (HWND) hb_parnl(1) )
);
}

HB_FUNC( CONNECTDRIVER )
{
  hb_retl( SendMessage ( (HWND) hb_parnl( 1 ),WM_CAP_DRIVER_CONNECT, hb_parni(2) , 0L) );
//  hb_retl( capDriverConnect( (HWND) hb_parnl( 1 ),hb_parni(2) ) );
}

HB_FUNC( DISCONNECTDRIVER )
{
  hb_retl( capDriverDisconnect( (HWND) hb_parnl( 1 ) ));
}

HB_FUNC( CAPCAPTURESETSETUP )
{
  CAPTUREPARMS Capture;
  hb_retl( capCaptureSetSetup( (HWND) hb_parnl( 1 ),&Capture, sizeof( CAPTUREPARMS ) ));
}


HB_FUNC( CAPGRABFRAME )
{
  hb_retl( capGrabFrame( (HWND) hb_parnl( 1 ) ) );
}


HB_FUNC( CAPFILESAVEAS )
{
  hb_retl( capFileSaveAs( (HWND) hb_parnl(1), hb_parc( 2
)));
}

/*
HB_FUNC( CapFileSetWebCamCaptureFile )
{
 BOOL fResult;
 fResult = CapFileSetWebCamCaptureFile( (HWND)hb_parnl(1),(LPSTR) hb_parc(2) );
 // preallocate a file of 5 MB.
 capFileAlloc( (HWND) hb_parnl(1), (1024L * 1024L * 5));
 hb_retl( fResult );
}
*/
HB_FUNC( CAPPREVIEW )
{
  hb_retl( capPreview( (HWND) hb_parnl( 1 ), hb_parl( 2 )
));
}

HB_FUNC( CAPPREVIEWSCALE )
{
  hb_retl( capPreviewScale( (HWND) hb_parnl( 1 ), hb_parl( 2 ) ));
}

HB_FUNC( CAPPREVIEWRATE )
{
  hb_retl( capPreviewRate( (HWND) hb_parnl( 1 ), hb_parni( 2 ) ));
}


HB_FUNC( CAPDLGVIDEOSOURCE )
{
  hb_retl( capDlgVideoSource( (HWND) hb_parnl( 1 ) ) );
}

HB_FUNC( CAPDLGVIDEODISPLAY )
{
  hb_retl( capDlgVideoDisplay( (HWND) hb_parnl( 1 ) ) );
}


HB_FUNC( CAPDLGVIDEOCOMPRESSION )
{
  hb_retl( capDlgVideoCompression( (HWND) hb_parnl(1)) );
}


HB_FUNC( SETUPVIDEO )
{
  CAPDRIVERCAPS CapDriverCaps;
  CAPSTATUS CapStatus;

  capDriverGetCaps( (HWND) hb_parnl( 1 ), &CapDriverCaps,sizeof (CAPDRIVERCAPS));

  // Video source dialog box.
  if (CapDriverCaps.fHasDlgVideoSource)
   capDlgVideoSource( (HWND) hb_parnl( 1 ) );

  // Video format dialog box.
  if (CapDriverCaps.fHasDlgVideoFormat)
     {
      capDlgVideoFormat( (HWND) hb_parnl( 1 ) );

      // Are there new image dimensions?
      capGetStatus( (HWND) hb_parnl( 1 ), &CapStatus, sizeof (CAPSTATUS));
      // New Dimensions of Window
      SetWindowPos( (HWND) hb_parnl( 1 ), NULL, 0, 0, CapStatus.uiImageWidth, CapStatus.uiImageHeight, SWP_NOZORDER| SWP_NOMOVE);

      // If so, notify the parent of a size change.
     }

   // Video display dialog box.
   if (CapDriverCaps.fHasDlgVideoDisplay)
       capDlgVideoDisplay( (HWND) hb_parnl( 1 ) );
}

HB_FUNC( CAPFRAMESPERSEC )  // hWnd, framesperSec
{
 CAPTUREPARMS CaptureParms;
 float FramesPerSec = (FLOAT)hb_parnl( 2 );

 capCaptureGetSetup( (HWND)hb_parnl(1), &CaptureParms,
sizeof(CAPTUREPARMS));
 CaptureParms.dwRequestMicroSecPerFrame = (DWORD) (1.0e6 /
FramesPerSec);
 hb_retl( capCaptureSetSetup( (HWND)hb_parnl(1),
&CaptureParms, sizeof (CAPTUREPARMS)) );
}


HB_FUNC( CAPOVERLAY )
{
  CAPDRIVERCAPS CapDrvCaps;
  capDriverGetCaps( (HWND) hb_parnl( 1 ), &CapDrvCaps,
sizeof (CAPDRIVERCAPS));

  if (CapDrvCaps.fHasOverlay)
      hb_retl( capOverlay( (HWND) hb_parnl( 1 ), hb_parl( 2
) ) );
  else
      hb_retl( FALSE );
}

HB_FUNC( CAPGETDRIVERS )
{
 char szDeviceName[80];
 char szDeviceVersion[80];
 int wIndex;
 // Maximos dispositivos a tratar. Del 0...9
 hb_reta(10);

 for (wIndex = 0; wIndex < 10; wIndex++)
     {
      if (capGetDriverDescription (wIndex, szDeviceName,
          sizeof (szDeviceName),
          szDeviceVersion,
          sizeof (szDeviceVersion)))
       {
         // Append name to list of installed capturedrivers
        // and then let the user select a driver to use.
        //MessageBox( GetActiveWindow(), szDeviceName,szDeviceVersion, MB_SYSTEMMODAL  );
         #ifdef __XHARBOUR__
            hb_storc( szDeviceName , -1, ( wIndex + 1 ) );
         #else
           hb_storvc( szDeviceName , -1, ( wIndex + 1 ) );
         #endif
   }
   }

}

HB_FUNC( CAPFILESAVEDIB )
{
 hb_retl( capFileSaveDIB( (HWND) hb_parnl( 1 ), hb_parc(2)
) );
}



//------------------------------------------------------------------------------

